=== debian/changelog ===
c-blosc (1.7.0-1) unstable; urgency=medium

  * Initial release (Closes: #786523)

 -- Jean-Christophe Jaskula <jean.christophe.jaskula@gmail.com>  Tue, 11 Aug 2015 19:40:49 -0400
