## c-blosc 1.9.0

=== debian/changelog ===
c-blosc (1.9.0-1) unstable; urgency=medium

  * New upstream version
  * Bump Standards-Version (no changes needed)
  * Enable hardening options

 -- Jean-Christophe Jaskula <jean.christophe.jaskula@gmail.com>  Thu, 19 May 2016 11:20:31 -0500
