=== blosc/CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
     if (LZ4_FOUND)
         include_directories( ${LZ4_INCLUDE_DIR} )
     else(LZ4_FOUND)
-        set(LZ4_LOCAL_DIR ${INTERNAL_LIBS}/lz4-1.7.0)
+        set(LZ4_LOCAL_DIR ${INTERNAL_LIBS}/lz4-1.7.2)
         include_directories( ${LZ4_LOCAL_DIR} )
     endif(LZ4_FOUND)
 endif(NOT DEACTIVATE_LZ4)
