=== tests/Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 EXECUTABLES := $(patsubst %.c, %.exe, $(SOURCES))
 
 # Support for internal LZ4 and LZ4HC
-LZ4_DIR = ../internal-complibs/lz4-1.7.0
+LZ4_DIR = ../internal-complibs/lz4-1.7.2
 CFLAGS += -DHAVE_LZ4 -I$(LZ4_DIR)
 BLOSC_LIB += $(wildcard $(LZ4_DIR)/*.c)
