=== debian/changelog ===
c-blosc (1.9.1-1) unstable; urgency=medium

  * New upstream version (fixes test failures on multiple archs)

 -- Jean-Christophe Jaskula <jean.christophe.jaskula@gmail.com>  Fri, 20 May 2016 16:19:53 -0400
