=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Jean-Christophe Jaskula <jean.christophe.jaskula@gmail.com>
 Build-Depends: debhelper (>= 9), cmake (>= 2.8.0), liblz4-dev (>= 0.0~r130), libsnappy-dev, zlib1g-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Section: libs
 Homepage: http://blosc.org/
 #Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/c-blosc.git
