## c-blosc 1.11.1+ds1

=== debian/changelog ===
c-blosc (1.11.1+ds1-3) unstable; urgency=medium

  * Add fix-nonlinux-ftbfs.patch (Closes: #844047) [thanks to Samuel
    Thibault].

 -- Daniel Stender <stender@debian.org>  Sun, 13 Nov 2016 21:02:02 +0100

c-blosc (1.11.1+ds1-2.2) unstable; urgency=medium

  * Non-maintainer upload
  * Fix typo in bigendian.patch

 -- Gilles Filippini <pini@debian.org>  Tue, 08 Nov 2016 19:00:48 +0100

c-blosc (1.11.1+ds1-2.1) unstable; urgency=medium

  * New patch bigendian.patch: fix endianness issue in the bitshuffle
    filter (closes: #8430040)

 -- Gilles Filippini <pini@debian.org>  Fri, 04 Nov 2016 11:19:43 +0100

c-blosc (1.11.1+ds1-2) unstable; urgency=medium

  * add preserve-cflags-from-environment.patch.
  * deb/rules: restore fPIE for hardening flags.

 -- Daniel Stender <stender@debian.org>  Sun, 04 Sep 2016 13:08:55 +0200

c-blosc (1.11.1+ds1-1) unstable; urgency=medium

  * new upstream release (Closes: #834318).
  * deb/control:
    + put myself into Maintainer field.
    + add docutils and links to build-deps (needed for READMEs).
    + drop version for cmake build-dep (not needed).
    + cosmetics, start short description with minuscules, removed trailing
      whitespace.
    + activate Vcs fields, use HTTPS for both.
  * deb/copyright:
    + add Files-Excluded for appyevor, internal-complibs and blosc/win32.
    + put * and debian/* under the BSD-3-clause (changed upstream).
    + add myself to copyright holders of debian/*, updated.
    + drop file and license paragraphs of things now removed from the upstream
      tarball.
    + add paragraph for internal-complibs/zstd-1.0.0 (temporarily shipped until
      it gets updated in Debian).
    + rearranged license paragraphs, removed some unnecessary blank lines.
  * deb/rules:
    + temporarily build with hardening flags without pie because of problems
      with cmake (internal -pthread test build fails with pie and std=gnu99).
    + drop inclusion of buildflags.mk (not needed).
    + add override for dh_installdocs to convert READMEs.
    + remove debmake comment lines.
  * deb/watch:
    + add dversionmangle and repacksuffix for +ds1 tarball.
  * drop deb/.git-dpm.
  * add deb/libblosc-dev.examples, deb/libblosc-dev.docs.

 -- Daniel Stender <stender@debian.org>  Sun, 04 Sep 2016 01:54:49 +0200
